# //////////////////////////////////////////////////////////////////////////////////////
#  WARRANTY: NONE. THIS PROGRAM WAS WRITTEN AS "SHAREWARE" AND IS AVAILABLE AS IS
#            AND MAY NOT WORK AS ADVERTISED IN ALL ENVIRONMENTS. THERE IS NO
#            SUPPORT FOR THIS PROGRAM
#      NOTE: YOU ARE STRONGLY ADVISED TO BACKUP YOUR DESIGN
#            BEFORE RUNNING THIS PROGRAM
#  TCL file: capSelectFilterFloat.tcl_v1-0_share.tcl
#
#  File location : <installation dir>/tools/capture/tclscripts/capAutoLoad folder
#  Purpose       : This script adds a floating selection menu which remains on screen
#					and changes the select filter dynamically.
#
#  Notes         : To use type ::capStFltr::SelectFilter in the command window
#                  or add this command to a TCL menu file.
#
# //////////////////////////////////////////////////////////////////////////////////////

package require Tcl 8.4
package require Tk
namespace eval ::capStFltr {
}
# Don't use root window. If . is not withdrawn then the selection window is not re-opened after it is closed.
wm withdraw .

 	set ::capStFltr::FilterFirstRun "true"
	
proc ::capStFltr::autoAdoptWindow { pWindow } {
    set l [array get ::env ORCAD_CAPTCL_ADOPT_CHILD]
	
    if { 0 != [llength $l] } {
	if { 1 == [string match -nocase "false" [lindex $l 1]] 
	 ||  1 == [string match -nocase "0" [lindex $l 1]]} {
	    return
	}
    }	    
	
    wm attributes $pWindow -toolwindow 1 
    update
    SetAppWindowAsParent [GetParent [winfo id $pWindow]]	
    
    #test -> wm geometry $pWindow -1000+0    
}

proc ::capStFltr::capSelectFilterInit {args} {
#Initialize all select options with "Select All"
	if {$::capStFltr::FilterFirstRun == "true"} {
	::capStFltr::prntFilterSelectAllXml 1
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
	set ::capStFltr::FilterFirstRun "false"
    }
}
	
proc ::capStFltr::SelectFilter {} {
 ::capStFltr::capSelectFilterInit
 tk::toplevel .t
 wm title .t "Share Selection Filter "
	set pWindow .t
#	withdraw $pWindow
#    wm attributes .t -toolwindow 1 
#    update
#   newParent = SetAppWindowAsParent [GetParent [winfo id .]]	
#  wm deiconify $pWindow
#wm transient .t $newParent
wm attributes .t -topmost 1 
grid [ttk::frame .t.c -padding "10"] -column 10 -row 10 -sticky n
grid columnconfigure .t.c 0 -weight 1; grid rowconfigure .t.c 0 -weight 1
grid [ttk::label .t.c.islbl1 -text "Schematic Page Selection Filter " ] -column 1 -row 1 -sticky wen
::capStFltr::st_place_window .t pointer

grid [ttk::checkbutton .t.c.parts -text "Parts" -variable partsBut  -onvalue "true" -offvalue "false" -command {if {$partsBut == "true"} {
	capStFltr::prntFilterXml Parts 1 17786
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} else {
	capStFltr::prntFilterXml Parts 0 17786
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} }] -column 1 -row 2 -sticky w

grid [ttk::checkbutton .t.c.nets -text "Nets" -variable netsBut -onvalue "true" -offvalue "false" -command {if {$netsBut == "true" } {
	capStFltr::prntFilterXml Nets 1 17787
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} else {
	capStFltr::prntFilterXml Nets 0 17787
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} }] -column 1 -row 3 -sticky w

grid [ttk::checkbutton .t.c.pgnd -text "Power/GND" -variable pgndBut -onvalue "true" -offvalue "false" -command {if {$pgndBut == "true" } {
	capStFltr::prntFilterXml Power/GND 1 17705
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} else {
	capStFltr::prntFilterXml Power/GND 0 17705
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} }] -column 1 -row 4 -sticky w

grid [ttk::checkbutton .t.c.hierport -text "Hierarchical Ports" -variable hierportBut -onvalue "true" -offvalue "false" -command {if {$hierportBut == "true" } {
	capStFltr::prntFilterXml {Hierarchical Ports} 1 17706
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} else {
	capStFltr::prntFilterXml {Hierarchical Ports} 0 17706
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} }] -column 1 -row 5 -sticky w

grid [ttk::checkbutton .t.c.offpage -text "Offpage Connectors" -variable offpageBut -onvalue "true" -offvalue "false" -command {if {$offpageBut == "true" } {
	capStFltr::prntFilterXml {Offpage Connectors} 1 17781
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} else {
	capStFltr::prntFilterXml {Offpage Connectors} 0 17781
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} }] -column 1 -row 6 -sticky w

grid [ttk::checkbutton .t.c.pins -text "Pins" -variable pinsBut -onvalue "true" -offvalue "false" -command {if {$pinsBut == "true" } {
	capStFltr::prntFilterXml {Pins} 1 17782
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} else {
	capStFltr::prntFilterXml {Pins} 0 17782
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} }] -column 1 -row 7 -sticky w

grid [ttk::checkbutton .t.c.title -text "Title Blocks" -variable titleBut -onvalue "true" -offvalue "false" -command {if {$titleBut == "true" } {
	capStFltr::prntFilterXml {Title Blocks} 1 17704
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} else {
	capStFltr::prntFilterXml {Title Blocks} 0 17704
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} }] -column 1 -row 8 -sticky w

grid [ttk::checkbutton .t.c.busentry -text "Bus Entry" -variable busentryBut -onvalue "true" -offvalue "false" -command {if {$busentryBut == "true" } {
	capStFltr::prntFilterXml {Bus Entry} 1 17783
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} else {
	capStFltr::prntFilterXml {Bus Entry} 0 17783
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} }] -column 1 -row 9 -sticky w

grid [ttk::checkbutton .t.c.graphic -text "Graphical Objects" -variable graphicBut -onvalue "true" -offvalue "false" -command {if {$graphicBut == "true" } {
	capStFltr::prntFilterXml {Graphical Objects} 1 17785
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} else {
	capStFltr::prntFilterXml {Graphical Objects} 0 17785
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} }] -column 1 -row 10 -sticky w

grid [ttk::checkbutton .t.c.markers -text "Markers" -variable markersBut -onvalue "true" -offvalue "false" -command {if {$markersBut == "true" } {
	capStFltr::prntFilterXml Markers 1 17780
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} else {
	capStFltr::prntFilterXml Markers 0 17780
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} }] -column 1 -row 11 -sticky w

grid [ttk::checkbutton .t.c.dispProp -text "Display Properties" -variable dispPropBut -onvalue "true" -offvalue "false" -command {if {$dispPropBut == "true" } {
	capStFltr::prntFilterXml {Display Properties} 1 17779
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} else {
	capStFltr::prntFilterXml {Display Properties} 0 17779
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} }] -column 1 -row 12 -sticky w

grid [ttk::checkbutton .t.c.alias -text "Net Alias" -variable aliasBut -onvalue "true" -offvalue "false" -command {if {$aliasBut == "true" } {
	capStFltr::prntFilterXml {Net Alias} 1 17784
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} else {
	capStFltr::prntFilterXml {Net Alias} 0 17784
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} }] -column 1 -row 13 -sticky w

grid [ttk::checkbutton .t.c.unconpins -text "Un - Connected Pins" -variable unconpinsBut -onvalue "true" -offvalue "false" -command {if {$unconpinsBut == "true" } {
	capStFltr::prntFilterXml {Un - Connected Pins} 1 33135
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
	#Capture sets pins with un-connected pins but does not unset pins when un-connected pins are unset.
	capStFltr::prntFilterXml {Pins} 1 17782
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	set ::pinsBut "true"
	file delete $::tempFltrName
} else {
	capStFltr::prntFilterXml {Un - Connected Pins} 0 33135
	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	file delete $::tempFltrName
} }] -column 1 -row 14 -sticky w

foreach padding [winfo children .t.c] {grid configure $padding -padx 10 -pady 1}

 grid [ttk::frame .t.b -padding "10"] -column 10 -row 20 -sticky s
 grid columnconfigure .t.b 0 -weight 1; grid rowconfigure .t.b 0 -weight 1

 grid [ttk::button .t.b.selAll -text "Select All" -command {::capStFltr::prntFilterSelectAllXml 1
 	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	::capStFltr::tickAllBoxes
	file delete $::tempFltrName
} ] -column 1 -row 21 -sticky sw 
   
 grid [ttk::button .t.b.clearAll -text "Clear All" -command {::capStFltr::prntFilterSelectAllXml 0
 	Menu "View::Selection Filter" | DialogBox  "OK" "$::tempFltrName"
	::capStFltr::untickAllBoxes
	file delete $::tempFltrName
} ] -column 2 -row 21 -sticky sw 
   
   
 grid [ttk::label .t.b.islbl2 -text " "] -column 2 -row 22 -sticky sw ;# Add vertical space between buttons.
 grid [ttk::button .t.b.close -text "Close" -command "destroy .t"] -column 2 -row 23 -sticky sw

 foreach padding [winfo children .t.b] {grid configure $padding -padx 10 -pady 1}
 focus .t.b.close	
}

proc ::capStFltr::prntFilterXml {selectFltrObjType selectFltrOnOffval selectFltrIDNum} {
global ::tempFltrName
	set ::tempFltrName "C:/temp/fltr_[pid].xml"
	set ::outfltr [open $::tempFltrName w]
	puts -nonewline $::outfltr {<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>
<DialogControls>
	<Control Type="AUTOCHECK_BOX" Enable="TRUE" Visible="TRUE" Id="} ; puts -nonewline $::outfltr "$selectFltrIDNum"; puts -nonewline $::outfltr {">
		<Value><![CDATA[}; puts -nonewline $::outfltr "$selectFltrOnOffval"; puts -nonewline $::outfltr {]]></Value>
		<Text><![CDATA[}; puts -nonewline $::outfltr "$selectFltrObjType"; puts -nonewline $::outfltr {]]></Text>
	</Control>
</DialogControls>}
	flush $::outfltr
	close $::outfltr
return $::tempFltrName
}

proc ::capStFltr::prntFilterSelectAllXml {selectFltrOnOffval} {
global ::tempFltrName
	set ::tempFltrName "C:/temp/fltr_[pid].xml"
	set ::outfltr [open $::tempFltrName w]
	puts -nonewline $::outfltr {<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>
<DialogControls>
	<Control Type="AUTOCHECK_BOX" Enable="TRUE" Visible="TRUE" Id="17786">
		<Value><![CDATA[}; puts -nonewline $::outfltr "$selectFltrOnOffval"; puts -nonewline $::outfltr {]]></Value>
		<Text><![CDATA[Parts]]></Text>
	</Control>
	<Control Type="AUTOCHECK_BOX" Enable="TRUE" Visible="TRUE" Id="17787">
		<Value><![CDATA[}; puts -nonewline $::outfltr "$selectFltrOnOffval"; puts -nonewline $::outfltr {]]></Value>
		<Text><![CDATA[Nets]]></Text>
	</Control>
	<Control Type="AUTOCHECK_BOX" Enable="TRUE" Visible="TRUE" Id="17704">
		<Value><![CDATA[}; puts -nonewline $::outfltr "$selectFltrOnOffval"; puts -nonewline $::outfltr {]]></Value>
		<Text><![CDATA[Title Blocks]]></Text>
	</Control>
	<Control Type="AUTOCHECK_BOX" Enable="TRUE" Visible="TRUE" Id="17705">
		<Value><![CDATA[}; puts -nonewline $::outfltr "$selectFltrOnOffval"; puts -nonewline $::outfltr {]]></Value>
		<Text><![CDATA[Power/GND]]></Text>
	</Control>
	<Control Type="AUTOCHECK_BOX" Enable="TRUE" Visible="TRUE" Id="17706">
		<Value><![CDATA[}; puts -nonewline $::outfltr "$selectFltrOnOffval"; puts -nonewline $::outfltr {]]></Value>
		<Text><![CDATA[Hierarchical Ports]]></Text>
	</Control>
	<Control Type="AUTOCHECK_BOX" Enable="TRUE" Visible="TRUE" Id="17779">
		<Value><![CDATA[}; puts -nonewline $::outfltr "$selectFltrOnOffval"; puts -nonewline $::outfltr {]]></Value>
		<Text><![CDATA[Display Properties]]></Text>
	</Control>
	<Control Type="AUTOCHECK_BOX" Enable="TRUE" Visible="TRUE" Id="17780">
		<Value><![CDATA[}; puts -nonewline $::outfltr "$selectFltrOnOffval"; puts -nonewline $::outfltr {]]></Value>
		<Text><![CDATA[Markers]]></Text>
	</Control>
	<Control Type="AUTOCHECK_BOX" Enable="TRUE" Visible="TRUE" Id="17781">
		<Value><![CDATA[}; puts -nonewline $::outfltr "$selectFltrOnOffval"; puts -nonewline $::outfltr {]]></Value>
		<Text><![CDATA[Offpage Connectors]]></Text>
	</Control>
	<Control Type="AUTOCHECK_BOX" Enable="TRUE" Visible="TRUE" Id="17782">
		<Value><![CDATA[}; puts -nonewline $::outfltr "$selectFltrOnOffval"; puts -nonewline $::outfltr {]]></Value>
		<Text><![CDATA[Pins]]></Text>
	</Control>
	<Control Type="AUTOCHECK_BOX" Enable="TRUE" Visible="TRUE" Id="17783">
		<Value><![CDATA[}; puts -nonewline $::outfltr "$selectFltrOnOffval"; puts -nonewline $::outfltr {]]></Value>
		<Text><![CDATA[Bus Entry]]></Text>
	</Control>
	<Control Type="AUTOCHECK_BOX" Enable="TRUE" Visible="TRUE" Id="17784">
		<Value><![CDATA[}; puts -nonewline $::outfltr "$selectFltrOnOffval"; puts -nonewline $::outfltr {]]></Value>
		<Text><![CDATA[Net Alias]]></Text>
	</Control>
	<Control Type="AUTOCHECK_BOX" Enable="TRUE" Visible="TRUE" Id="17785">
		<Value><![CDATA[}; puts -nonewline $::outfltr "$selectFltrOnOffval"; puts -nonewline $::outfltr {]]></Value>
		<Text><![CDATA[Graphical Objects]]></Text>
	</Control>
	<Control Type="AUTOCHECK_BOX" Enable="TRUE" Visible="TRUE" Id="33135">
		<Value><![CDATA[}; puts -nonewline $::outfltr "$selectFltrOnOffval"; puts -nonewline $::outfltr {]]></Value>
		<Text><![CDATA[Un - Connected Pins]]></Text>
	</Control>
</DialogControls>}
	flush $::outfltr
	close $::outfltr
return $::tempFltrName
}

proc ::capStFltr::tickAllBoxes {} {
set ::partsBut "true"; set ::netsBut "true"; set ::pgndBut "true"; set ::hierportBut "true"; set ::offpageBut "true"; set ::pinsBut "true"
set ::titleBut "true"; set ::busentryBut "true"; set ::graphicBut "true"; set ::markersBut "true"; set ::dispPropBut "true";
set ::aliasBut "true"; set ::unconpinsBut "true"}

proc ::capStFltr::untickAllBoxes {} {
set ::partsBut "false"; set ::netsBut "false"; set ::pgndBut "false"; set ::hierportBut "false"; set ::offpageBut "false"; set ::pinsBut "false"
set ::titleBut "false"; set ::busentryBut "false"; set ::graphicBut "false"; set ::markersBut "false"; set ::dispPropBut "false";
set ::aliasBut "false"; set ::unconpinsBut "false"}


## st_place_window: place a toplevel at a particular position
##
## ARGS: toplevel ?placement_type? ?args?
## toplevel     - name of toplevel window
## placement    - pointer ?center? ; places $w centered on the pointer
##                widget widget_name ; centers $w over widget_name
##                defaults to placing toplevel in the middle of the screen
##
proc ::capStFltr::st_place_window {w {p ""} {a ""}} {
  wm withdraw $w
  update idletasks
  switch -glob -- $p {
    p* {
      ## place at POINTER (centered is $a == center)
      if [string match c* $a] {
        wm geometry $w +[expr \
            [winfo pointerx $w]-[winfo width $w]/2]+[expr \
            [winfo pointery $w]-[winfo height $w]/2]
      } else {
        wm geometry $w +[winfo pointerx $w]+[winfo pointery $w]
      }
    }
    w* {
      ## center about WIDGET $a
      wm geometry $w +[expr [winfo rootx $a]+([winfo width $a]\
          -[winfo width $w])/2]+[expr \
          [winfo rooty $a]+([winfo height $a]-[winfo height $w])/2]
    }
    default {
      wm geometry $w +[expr ([winfo screenwidth $w]-[winfo reqwidth $w]) \
          / 2]+[expr ([winfo screenheight $w]-[winfo reqheight $w]) / 2]
    }
  }
  wm deiconify $w
}

#Initialize all checkboxes to selected.
	::capStFltr::tickAllBoxes
#Initialize all checkboxes to UNselected.
#	::capStFltr::untickAllBoxes

